"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

function _default(_ref) {
  var t = _ref.types;
  return {
    visitor: {
      CallExpression: function CallExpression(path) {
        var property = path.node.callee.property;

        if (property && property.name === 'componentDidCatch') {
          // Path that leads to the `componentDidCatch` call arguments
          var componentDidCatchSecondArgPath = path.get('arguments.1');
          var properties = componentDidCatchSecondArgPath.node.properties;
          var variableDeclaration = path.getStatementParent().container[1].declarations.find(function (n) {
            return n.type === 'VariableDeclarator' && n.init.property.name === 'stack';
          });

          if (properties && properties[0].key.name === 'componentStack' && variableDeclaration) {
            var sourceObjName = variableDeclaration.init.object.name; // Modify `componentDidCatch` second argument to add a single line

            componentDidCatchSecondArgPath.replaceWithSourceString("{\n              componentStack: stack !== null ? stack : '',\n              source: ".concat(sourceObjName, ".source,\n            }"));
          }
        }
      }
    }
  };
}